%  InverseModels.m
%  -------
%  Creates and validates the inverse linear ARX model structure.        
%  Written by : Oskar Gross
%  LastEditDate  : May, 30, 2009

% Network definition, where the first row is hidden layer and second row is
% the output layer

[u_test u_train u_valid y_test y_train y_valid] = PrepareData();
lag = 4;

NetDef = ['LL';'L-'];
trparms = settrain;
   
% Initialize network weights
W1 = [];
W2 = [];

% Define the lag structure
% NN=[na nb nk].
% na = # of past out puts used for determining the prediction
% nb = # of past inputs used for determining prediction
% nk = time delay (usually 1)
NN = [lag lag 1];

[W1,W2,PI_vector,iteration,lambda]=general(NetDef,NN,W1,W2,trparms,y_train,u_train);

[Uhat,PI]=invsim(NetDef,NN,W1,W2,y_valid,u_valid);