%  NNARX.m
%  -------
%  Creates and validates the linear NNARX model structure.        
%  Written by : Oskar Gross
%  LastEditDate  : May, 24, 2009

% Network definition, where the first row is hidden layer and second row is
% the output layer

%% Create, train and validate neural network with lag-space of 2
% Prepare the data first
[u_test u_train u_valid y_test y_train y_valid] = PrepareData();

NetDef = ['LHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH';'L--------------------------------'];

trparms = settrain;
   
% Initialize network weights
W1 = [];
W2 = [];

% Define the lag structure
% NN=[na nb nk].
% na = # of past out puts used for determining the prediction
% nb = # of past inputs used for determining prediction
% nk = time delay (usually 1)
NN = [4 4 1];

[W1,W2,PI_vector,iteration,lambda]=nnarx(NetDef,NN,W1,W2,trparms,y_train,u_train);

[Yhat,NSSE]=nnvalid('nnarx',NetDef,NN,W1,W2,y_test,u_test);

[meanError] = meanSquaredError(y_test,Yhat,4);

%% Analyze k-predictions performance

Yhat=kpredict('nnarx',NetDef,NN,1,W1,W2,y_valid,u_valid);

[meanErrorPredict] = meanSquaredError(y_valid,Yhat,1);


Yhat=kpredict('nnarx',NetDef,NN,3,W1,W2,y_valid,u_valid);

[meanErrorPredict3] = meanSquaredError(y_valid,Yhat,3);


Yhat=kpredict('nnarx',NetDef,NN,20,W1,W2,y_valid,u_valid);

[meanErrorPredict20] = meanSquaredError(y_valid,Yhat,20);